{
Autor: DrakMrak; modif: Arne1
Sekce: Knihovna
Plugin pro nastaveni BadgeGen II - pro genrovani odznacku do statistik
}
//------------------------------------------------------------------------------
const
  PLGROUP = '\plgroup.ggp.txt'; //soubor s definicemi skupin pro spravce pluginu
var
  //-----------------------------------------color
  FColor		:	array of TFColor;
  //-------------
  coG1			:	String;		//Graf 1
  coG2			:	String;		//Graf 2
  coGTxt		:	String;		//Graf Text
  coB1			:	String;		//Tlatko 1
  coB2			:	String;		//Tlatko 2
  coB3			:	String;		//Tlatko 3
  coBT1			:	String;		//Tlatko text 1
  coBT2			:	String;		//Tlatko text 2
  coBT3			:	String;		//Tlatko text 3
//------------------------------------------------------------------------------
var
  MainText: 					String;		//=000000
  MainBkg:						String; 	//=fbfbfb
  FrameTitleText:				String;		//=000000
  FrameTitleBkg:				String;		//=ffffff
  TitleText:					String;		//=000000
  TitleBkg:						String;		//=ccdce4
  //zahlavi pro tabulku typu seznam
  // 2 zahlavi pro tabulku typu matrix (D/T, hodiny v tydnu, dny v roce, ...)
  TableMatrixHeaderBkg1:		String;		//=457f9c
  TableMatrixHeaderBkg2:		String;		//=95cfec

  TableListHeaderText:			String;		//=000000
  TableListHeaderBkg:			String;		//=ccdce4
  TableEmptyText:				String;		//=000000
  TableEmptyBkg:				String;		//=e7f3f8
  TableEmptyTextOdd:			String;		//=535353
  TableEmptyBkgOdd:				String;		//=CFE7F1
  TableValueText:				String;		//=000000
  TableValueBkg:				String;		//=ebeff5
  TableMaxText:					String;		//=008040
  TableAvgText:					String;		//=90cae6
  TableMinText:					String;		//=ecdce4

  TableScaleMinBkg:				String;		//=ccdce4
  TableScaleAvgBkg:				String;		//=86AFC4
  TableScaleMaxBkg:				String;		//=457f9c
  TableScaleText:				String;		//=444444
  
  iWidth:						String;		//ka formu
//------------------------------------------------------------------------------
procedure SetStatorColors(Stator:boolean);
var
	iniSFile: TINIFile;
begin
	if Stator then begin			//STATOR
		MainText := '%ColorMainText%';
		MainBkg := '%ColorMainBkg%';
		FrameTitleText := '%ColorFrameTitleText%';
		FrameTitleBkg := '%ColorFrameTitleBkg%';
		TitleText := '%ColorTitleText%';
		TitleBkg := '%ColorTitleBkg%';
		//zahlavi pro tabulku typu seznam
		// 2 zahlavi pro tabulku typu matrix (D/T, hodiny v tydnu, dny v roce, ...)
		TableMatrixHeaderBkg1 := '%ColorTableMatrixHeaderBkg1%';
		TableMatrixHeaderBkg2 := '%ColorTableMatrixHeaderBkg2%';
		//
		TableListHeaderText := '%ColorTableListHeaderText%';
		TableListHeaderBkg := '%ColorTableListHeaderBkg%';
		TableEmptyText := '%ColorTableText%';
		TableEmptyBkg := '%ColorTableBkg%';
		TableEmptyTextOdd := '%ColorTableTextOdd%';
		TableEmptyBkgOdd := '%ColorTableBkgOdd%';
		TableValueText := '%ColorTableValueText%';
		TableValueBkg := 'ColorTableValueBkg';
		TableMaxText := '%ColorTableMaxText%';
		TableAvgText := '%ColorTableAvgText%';
		TableMinText := '%ColorTableMinText%';
		//
		TableScaleMinBkg := '%ColorTableScaleMinBkg%';
		TableScaleAvgBkg := '%ColorTableScaleAvgBkg%';
		TableScaleMaxBkg := '%ColorTableScaleMaxBkg%';
		TableScaleText := '%ColorTableScaleText%';
		//
		iniSFile := TIniFile.Create(GEOGET_SCRIPTDIR + '\Stator\Profiles\' + GEOGET_OWNER + '\Layout.ini');
		iWidth := '680';
		//
		try
			//Max ka ze STATORU------------------------------------------------------------------
			iWidth := iniSFile.ReadString('LAYOUT','WIDTH','720');
			iWidth := IntToStr(StrToInt(iWidth) - 20);
			//--------------------------------------------------------------------------------------
		finally
			iniSFile.Free;
		end;
	end
	else begin										//GGSTAT
		MainText := '000000';
		MainBkg := 'ffffff';
		FrameTitleText := '000000';
		FrameTitleBkg := 'ffffff';
		TitleText := '%ColorTitleText%';
		TitleBkg := '%ColorTitleBkg%';
		//zahlavi pro tabulku typu seznam
		// 2 zahlavi pro tabulku typu matrix (D/T, hodiny v tydnu, dny v roce, ...)
		TableMatrixHeaderBkg1 := 'FF7D73';
		TableMatrixHeaderBkg2 := '99FF66';
		//
		TableListHeaderText := '000000';
		TableListHeaderBkg := 'ffffcc';
		TableEmptyText := '000000';
		TableEmptyBkg := 'ffffcc';
		TableEmptyTextOdd := '000000';
		TableEmptyBkgOdd := 'FFCC00';
		TableValueText := '000000';
		TableValueBkg := 'ffffcc';
		TableMaxText := '%ColorTableMaxText%';
		TableAvgText := '%ColorTableAvgText%';
		TableMinText := '%ColorTableMinText%';
		//
		TableScaleMinBkg := coG2;
		TableScaleAvgBkg := '%ColorTableScaleAvgBkg%';
		TableScaleMaxBkg := coG1;
		TableScaleText := coGTxt;
		//
		iWidth := BGSForm_edWidth.Text;
	end;
end;

function CleanupHtml(Text : String) : String;
begin
    Result := Text;
    // Comment -> ''
    Result := RegexReplace('(?si)<!--.*?-->', Result, '', false);
      
    // TAG -> ''
    //SPAN, TABLE, TD, TR, TH, DIV, FONT, A, I, IMG, MARQUEE, CENTER, BLOCKQUOTE
    Result := RegexReplace('(?si)< *?(/|)?(span|table|td|tr|th|div|font|a|i|img|marquee|center|blockquote).*?>', Result, '', false);
    
    // TAG -> Paragraph
    // P, LI, UL, OL, H1 - H6
    Result := RegexReplace('(?si)< *?(/)?(p|li|ul|ol|h\d).*?>', Result, '<$1p>', true);

    //Remove unnecessary CRLF
    Result := ReplaceString(Result,CRLF, ' ');
end;

function alphabetic ( ch : char ) : boolean;
begin
    if ( ((ch >= 'a') AND (ch <= 'z')) OR ((ch >= 'A') AND (ch <= 'Z')) OR ((ch >= '0') AND (ch <= '9')) 
	   OR (ch = '_') OR (ch = '[') OR (ch = ']') OR (ch = '(') OR (ch = ')') OR (ch = ':') OR (ch = ';')
	   OR (ch = '!') OR (ch = '?') OR (ch = '}') OR (ch = '{') OR (ch = '^')) then
       Result := TRUE
    else
       Result := FALSE;
end;

{ a function to count the number of words in a string }
function count_words ( var line : string ) : integer;
var  i, word_count : integer;
     looking_for_word : boolean;
begin
    looking_for_word := TRUE;
    word_count := 0;
    for i := 1 to length(line) do
    begin
        if alphabetic( line[i] ) then
        begin
           if looking_for_word then
           begin
               word_count := word_count + 1;
               looking_for_word := FALSE
           end
        end
        else
           looking_for_word := TRUE;
    end;
    Result := word_count
end;

//Rychl tdn poloek
procedure QuickSort(var A: array of TFCache; iLo, iHi: Integer) ;
 var
   Lo, Hi: integer;
   Pivot, T: TFCache;
 begin
   Lo := iLo;
   Hi := iHi;
   if Lo = Hi then exit;
   //-------------------------------------------------------
   Pivot := A[(Lo + Hi) div 2];
   repeat
     while A[Lo].FDatumFull < Pivot.FDatumFull do Inc(Lo) ;
     while A[Hi].FDatumFull > Pivot.FDatumFull do Dec(Hi) ;
     if Lo <= Hi then
     begin
       T := A[Lo];
       A[Lo] := A[Hi];
       A[Hi] := T;
       Inc(Lo) ;
       Dec(Hi) ;
     end;
   until Lo > Hi;
   if Hi > iLo then QuickSort(A, iLo, Hi) ;
   if Lo < iHi then QuickSort(A, Lo, iHi) ;
 end;
 
 //Translate given base64 encoded string into bitmap
procedure BitmapStringToBitmap(bmp : String; const Value: TBitMap);
var
  ms : TMemoryStream;
  ic : String;
begin
  ms := TMemoryStream.Create;
  try
    try
      ic := DecodeBase64(bmp);
      ms.Write(ic, Length(ic));
      ms.Position := 0;
      Value.LoadFromStream(ms);
    except
    end;
  finally
    ms.free;
  end;
end;

//KeyPress ---------------------------------------------------------------------
procedure edKeyPress(Sender: TObject; var Key: Char);
begin
  Ttm.Enabled := false;	
  if not (((Key >= '0') and (Key <= '9')) or (Key = Char(#8))) then Key := #0;
end;

//TextChange
procedure textChange(Sender: TObject);
var
	text : String;
	atx : TEdit;
begin
	atx := (Sender As TEdit);
	text := atx.Text;
	atx.OnChange := nil;
	if text = '' then exit;
	try
		{if text = '' then begin
			atx.Text := '0';
			atx.SelStart := length(atx.Text);
			exit;
		end;}
		if StrToInt64(text) > 999999 then begin
			atx.Text := '999999';
			atx.SelStart := length(atx.Text);
			exit;
		end;
	finally
		atx.OnChange := @textChange;
	end;
end;

//Timer
procedure OnTimerTick(Sender : TObject);
var 
  i, h, k: integer;
  msg: integer;
  zero: integer;
begin
  k := BGMSForm_pbarStart.Position + 1;	
  if k = 101 then begin
	BGMSForm_pbarStart.Position := k;
	h := BGMSForm_btnGo.Handle;
	msg := 245;
	zero := 0;
	i := SendMessage(h, msg, zero, zero);
  end
  else
    BGMSForm_pbarStart.Position := k;
end;

procedure ClickToForm(Sender: TObject;  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
  Ttm.Enabled := false;	
end;

//------------------------------------------------------------------------------
procedure PluginWork;
var
  gcX, gcY: extended;
  Dist: extended;
  i :integer;
  ct: boolean;
begin
	//Naten ke -------------------------------------------
    //Poet vlastnch ke
	if GC.IsOwner then begin
	  if (GC.CacheType = 'Event Cache') or 
	     (GC.CacheType = 'Mega-Event Cache') or
		 (GC.CacheType = 'Cache In Trash Out Event') or
		 (GC.CacheType = 'Lost and Found Event Cache') then 
	  begin
	    //Eventy
		MyEvent := MyEvent + '''' + GC.ID + ''',';
		Inc(CountEOwner);
	  end
	  else begin
	    //Kee
		MyCache := MyCache + '''' + GC.ID + ''',';
	    Inc(CountOwner);
	  end;
	  //vechny typy ke i eventy
	  if Length(CacheOwnType) = 0 then begin
		SetLength(CacheOwnType, 1);
		CacheOwnType[0] := GC.CacheType;
	  end
	  //Size
	  else begin
		ct:= false;
		for i:= Low(CacheOwnType) to High(CacheOwnType) do
		  if CacheOwnType[i] = GC.CacheType then ct := true;
		if not ct then begin
		  SetLength(CacheOwnType, Length(CacheOwnType)+1);
		  CacheOwnType[Length(CacheOwnType)-1] := GC.CacheType;
		end;
	  end;
	  //vechny size ke i eventy
	  if Length(CacheOwnBSize) = 0 then begin
		SetLength(CacheOwnBSize, 1);
		CacheOwnBSize[0] := GC.Size;
	  end
	  else begin
		ct:= false;
		for i:= Low(CacheOwnBSize) to High(CacheOwnBSize) do
		  if CacheOwnBSize[i] = GC.Size then ct := true;
		if not ct then begin
		  SetLength(CacheOwnBSize, Length(CacheOwnBSize)+1);
		  CacheOwnBSize[Length(CacheOwnBSize)-1] := GC.Size;
		end;
	  end;
	end;
	//Poty a seznam odlovench ke
	if GC.IsFound then 
	begin
	  //poet nalezench celkem
	  Inc(CountFound);
	  //nejvzdlenj ke
	  if Pos(GC.ID ,distIgnore) = 0 then begin	//pokud je v seznamu pro ignorovn tak se ignboruje IGNOREBYDISTANCE
		gcX:= StrToFl(GC.CoordX);
		gcY:= StrToFl(GC.CoordY);
		Dist := PointDistance(refX, refY, gcX, gcY);
		if Dist > maxDistance then maxDistance := Dist;
	  end;
	  //else ShowMessage(distIgnore);
	  //nacist data
	  Inc(GCExtCount);
	  SetLength(GCExt, GCExtCount);
	  with GCExt[GCExtCount-1] do 
	  begin
	    ID:= GC.ID;						  	  		//ID kee
		FDatum:= GC.Found + EncodeTime(0,0,1,0);	//datum	
		FDatumFull:= GC.Found + GC.FoundTime; 		//datum i s asem
		CoordX:= GC.CoordX;				  	  		//koordinty X
		CoordY:= GC.CoordY;				  	  		//koordinty Y
	  end;
	end;
	//----------------------------------------------------------
	Inc(cnt);
	GeoBusyProgress(cnt,geoget_maxcount);
	if GeoBusyTest then begin
		SetLength(CacheOwnType,0);  
		SetLength(GCExt, 0);	
		GeoAbort;
	end;
end;
//ComboInit
procedure ComboInit;
begin
  //Badge type initialization
  BGSForm_cbFrom.items.Add(_('[B] Bronze'));
  BGSForm_cbFrom.items.Add(_('[S] Silver'));
  BGSForm_cbFrom.items.Add(_('[G] Gold'));
  BGSForm_cbFrom.items.Add(_('[P] Platinum'));
  BGSForm_cbFrom.items.Add(_('[R] Ruby'));
  BGSForm_cbFrom.items.Add(_('[Sa] Sapphire'));
  BGSForm_cbFrom.items.Add(_('[E] Emerald'));
  BGSForm_cbFrom.items.Add(_('[D] Diamond'));
  //
  BGSForm_cbFrom.ItemIndex := 0;
  //Language initializace
  BGSForm_cbLang.items.Add('EN');
  BGSForm_cbLang.items.Add('CZ');
  //
  BGSForm_cbLang.ItemIndex := 0;
  //Encode initialization
  BGSForm_cbFormat.items.Add('ANSI');
  BGSForm_cbFormat.items.Add('UTF');
  //
  BGSForm_cbFormat.ItemIndex := 0;
  //vbr cesty k odznkm
  BGSForm_cbHTML.items.Add('http://gc.zlej.net/b/');
  BGSForm_cbHTML.items.Add('http://www.geotrebic.cz/b/');
  BGSForm_cbHTML.items.Add('http://www.geocaching.cz/stator/img/bg/');
  //Sem se mohou pidat dal adresy na servry s odznky-----^
  BGSForm_cbHTML.ItemIndex := 0;
end;
//INI---------------------------------------------------------------------------
procedure CheckValue;
begin
	//Mini
	if BGMSForm_edTrackAll.Text = '' then BGMSForm_edTrackAll.Text := '0';
	if BGMSForm_edTB.Text = '' then BGMSForm_edTB.Text := '0';
	if BGMSForm_edScuba.Text = '' then BGMSForm_edScuba.Text := '0';
	if BGMSForm_edCWG.Text = '' then BGMSForm_edCWG.Text := '0';
	if BGMSForm_edBench.Text = '' then BGMSForm_edBench.Text := '0';
	if BGMSForm_edOwl.Text = '' then BGMSForm_edOwl.Text := '0';
	if BGMSForm_edPhoto.Text = '' then BGMSForm_edPhoto.Text := '0';
	//Velk
	if BGSForm_edTrackAll.Text = '' then BGSForm_edTrackAll.Text := '0';
	if BGSForm_edTB.Text = '' then BGSForm_edTB.Text := '0';
	if BGSForm_edScuba.Text = '' then BGSForm_edScuba.Text := '0';
	if BGSForm_edCWG.Text = '' then BGSForm_edCWG.Text := '0';
	if BGSForm_edBench.Text = '' then BGSForm_edBench.Text := '0';
	if BGSForm_edOwl.Text = '' then BGSForm_edOwl.Text := '0';
	if BGSForm_edPhoto.Text = '' then BGSForm_edPhoto.Text := '0';
	//zbytek
	if BGSForm_edWidth.Text = '' then BGSForm_edWidth.Text := '720';
	if BGSForm_edMaxHeight.Text = '' then BGSForm_edMaxHeight.Text := '620';
	if BGSForm_edBGSize.Text = '' then BGSForm_edBGSize.Text := '100';
	if BGSForm_edBBSize.Text = '' then begin
		BGSForm_edBBSize.Text := IntToStr(Round(((StrToInt(trim('175'))+1) * 100) / 175));
	end;
end;
//
//
procedure MiniToNormal;
begin
	CheckValue;
	BGSForm_edTrackAll.Text := 	BGMSForm_edTrackAll.Text;
	BGSForm_edTB.Text 		:=	BGMSForm_edTB.Text;
	BGSForm_edScuba.Text 	:= 	BGMSForm_edScuba.Text;
	BGSForm_edCWG.Text 		:= 	BGMSForm_edCWG.Text;
	BGSForm_edBench.Text 	:=	BGMSForm_edBench.Text;
	BGSForm_edOwl.Text 		:= 	BGMSForm_edOwl.Text;
	BGSForm_edPhoto.Text 	:=  BGMSForm_edPhoto.Text;
end;
//------------------------------------------------------------------------------
function ReadFromCFG : boolean;
var
  ggsURL	:String;
  ggsFrom	:String;
  ggsPBsize	:String;
  ggs2DB	:String;
  ggsEncode :String;
  ggsLang	:String;
begin
  iniFile := TIniFile.Create(GEOGET_SCRIPTDIR + '\BadgeGenII\' + INI_FILE);
  //html
  try
	  BGSForm_chbBeltShow.checked 		:= iniFile.ReadBool('HTML','BeltYesNo',True);
	  BGSForm_chbBVII.checked 			:= iniFile.ReadBool('HTML','BeltVII',True);
	  BGSForm_chbShow.checked 			:= iniFile.ReadBool('HTML','ShowInfo',True);
	  BGSForm_chbUS.checked 			:= iniFile.ReadBool('HTML','Euro_vs_USA',False);
	  BGSForm_chbGraph.checked 			:= iniFile.ReadBool('HTML','Graph',True);
	  BGSForm_chbNumber.checked 		:= iniFile.ReadBool('HTML','GraphNumber',False);
	  ggsURL 							:= iniFile.ReadString('HTML','Url','http://gc.zlej.net/b/');
	  ggsFrom							:= iniFile.ReadString('HTML','From','[B] Bronze');
	  BGSForm_edTabs1.Text 				:= iniFile.ReadString('HTML','Tab1','award BadgeGens');
	  BGSForm_edTabs2.Text 				:= iniFile.ReadString('HTML','Tab2','all BadgeGens');
	  BGSForm_edTabs3.Text 				:= iniFile.ReadString('HTML','Tab3','more info');
	  BGSForm_chbCompact.checked		:= iniFile.ReadBool('HTML','Compact',False);
	  BGSForm_chbVisible.checked 		:= iniFile.ReadBool('HTML','GVisible',False);
	  ggsEncode					 		:= iniFile.ReadString('HTML','Encoding','ANSI');
	  ggsLang							:= iniFile.ReadString('HTML','Language','EN');
	  BGSForm_chbDetail.checked			:= iniFile.ReadBool('HTML','ShowDetail',False);
	  BGSForm_chbSFlags.checked			:= iniFile.ReadBool('HTML','FlagsSepare',False);
	  //BGSForm_chbStator.checked			:= iniFile.ReadBool('HTML','Stator',False);
	  if GEOGET_SCRIPTPARENT = '' then BGSForm_chbStator.checked := false
	  else begin
		if Pos('Stator', GEOGET_SCRIPTPARENT) > 0 then BGSForm_chbStator.checked := true
		else BGSForm_chbStator.checked := false;
	  end;
	  //color HTML
	  coG1								:= iniFile.ReadString('HTML','CoGraf1','A2C180');
	  coG2								:= iniFile.ReadString('HTML','CoGraf2','F7B9BA');
	  coGTxt							:= iniFile.ReadString('HTML','CoGrafTxt','000000');
	  coB1								:= iniFile.ReadString('HTML','CoButton1','000000');
	  coB2								:= iniFile.ReadString('HTML','CoButton2','ffffff');
	  coB3								:= iniFile.ReadString('HTML','CoButton3','1e90ff');
	  coBT1								:= iniFile.ReadString('HTML','CoButtonTxt1','ffffff');
	  coBT2								:= iniFile.ReadString('HTML','CoButtonTxt2','000000');
	  coBT3								:= iniFile.ReadString('HTML','CoButtonTxt3','000080');
	  //inicializace
	  BGMSForm_edTrackAll.Text 			:= iniFile.ReadString('Initial','Trackables','0');
	  BGMSForm_edTB.Text 				:= iniFile.ReadString('Initial','TBs','0');
	  BGMSForm_edScuba.Text 			:= iniFile.ReadString('Initial','Scubas','0');
	  BGMSForm_edCWG.Text 				:= iniFile.ReadString('Initial','CWGs','0');
	  BGMSForm_edBench.Text 			:= iniFile.ReadString('Initial','Benchmarks','0');
	  BGMSForm_edOwl.Text 				:= iniFile.ReadString('Initial','Owls','0');
	  BGMSForm_edPhoto.Text 			:= iniFile.ReadString('Initial','Photo','0');
	  MiniToNormal;						//Zkopruju data z minidialogu do velkho dialogu
	  //DB
	  ggs2DB							:= iniFile.ReadString('DB','SecondDB','');
	  //Size
	  BGSForm_edWidth.Text 				:= iniFile.ReadString('Size','PageWidth','720');
	  BGSForm_edMaxHeight.Text 			:= iniFile.ReadString('Size','PageMaxHeight','620');
	  BGSForm_edBGSize.Text 			:= iniFile.ReadString('Size','ProcBadgeSize','100');
	  ggsPBsize 						:= iniFile.ReadString('Size','ProcBeltSize','175');
	  BGSForm_edBBSize.Text 			:= IntToStr(Round(((StrToInt(trim(ggsPBsize))+1) * 100) / 175));
	  //odznacky
	  BGSForm_chbgTraditional.checked 	:= iniFile.ReadBool('Badges','Traditional',True);
	  BGSForm_chbgMulti.checked 		:= iniFile.ReadBool('Badges','Multi',True);
	  BGSForm_chbgMystery.checked 		:= iniFile.ReadBool('Badges','Mysterious',True);
	  BGSForm_chbgVirtual.checked 		:= iniFile.ReadBool('Badges','Virtual',True);
	  BGSForm_chbgEarth.checked			:= iniFile.ReadBool('Badges','Earth',True);
	  BGSForm_chbgLetter.checked		:= iniFile.ReadBool('Badges','Letter',True);
	  BGSForm_chbgWherigo.checked		:= iniFile.ReadBool('Badges','Wherigo',True);
	  BGSForm_chbgMEvent.checked		:= iniFile.ReadBool('Badges','MEvent',True);
	  BGSForm_chbgEvent.checked			:= iniFile.ReadBool('Badges','Event',True);
	  BGSForm_chbgCITO.checked			:= iniFile.ReadBool('Badges','CITO',True);
	  BGSForm_chbgLostFound.checked		:= iniFile.ReadBool('Badges','LostFound',False);
	  BGSForm_chbgBenchmark.checked		:= iniFile.ReadBool('Badges','Benchmarker',False);
	  BGSForm_chbgWebcam.checked		:= iniFile.ReadBool('Badges','Webcam',True);
	  BGSForm_chbgApe.checked			:= iniFile.ReadBool('Badges','Ape',False);
	  BGSForm_chbgLab.checked			:= iniFile.ReadBool('Badges','Lab',False);   //Arne1
	  //
	  BGSForm_chbgMicro.checked			:= iniFile.ReadBool('Badges','Micro',True);
	  BGSForm_chbgSmall.checked			:= iniFile.ReadBool('Badges','Small',True);
	  BGSForm_chbgRegular.checked		:= iniFile.ReadBool('Badges','Regular',True);
	  BGSForm_chbgLarge.checked			:= iniFile.ReadBool('Badges','Large',True);
	  //
	  BGSForm_chbgExtreme.checked		:= iniFile.ReadBool('Badges','Extrem',True);
	  BGSForm_chbgLazy.checked			:= iniFile.ReadBool('Badges','Lazy',True);
	  BGSForm_chbgDiff.checked			:= iniFile.ReadBool('Badges','Diff',True);
	  BGSForm_chbgTerr.checked			:= iniFile.ReadBool('Badges','Terr',True);
	  //
	  BGSForm_chbgFTF.checked			:= iniFile.ReadBool('Badges','FTF',True);
	  BGSForm_chbgWPed.checked			:= iniFile.ReadBool('Badges','WPedestal',True);
	  //
	  BGSForm_chbgHidden.checked		:= iniFile.ReadBool('Badges','Hidden',True);
	  BGSForm_chbgHost.checked			:= iniFile.ReadBool('Badges','Host',True);
	  //
	  BGSForm_chbgElevation.checked		:= iniFile.ReadBool('Badges','Elevation',True);
	  BGSForm_chbgLowe.checked			:= iniFile.ReadBool('Badges','UnderGround',True);
	  //
	  BGSForm_chbgTraveling.checked		:= iniFile.ReadBool('Badges','Travel',True);
	  BGSForm_chbgBusy.checked			:= iniFile.ReadBool('Badges','Busy',True);
	  BGSForm_chbgDaily.checked			:= iniFile.ReadBool('Badges','Daily',True);
	  BGSForm_chbgCalendar.checked		:= iniFile.ReadBool('Badges','Calendar',True);
	  BGSForm_chbgScuba.checked			:= iniFile.ReadBool('Badges','Scuba',True);
	  BGSForm_chbgLongDistance.checked	:= iniFile.ReadBool('Badges','Distance',True);
	  BGSForm_chbgMatrix.checked		:= iniFile.ReadBool('Badges','Matrix',True);
	  BGSForm_chbgTB.checked			:= iniFile.ReadBool('Badges','TravelBug',True);
	  BGSForm_chbgCoin.checked			:= iniFile.ReadBool('Badges','Coin',True);
	  BGSForm_chbgCWG.checked			:= iniFile.ReadBool('Badges','CWG',True);
	  BGSForm_chbgAuthor.checked		:= iniFile.ReadBool('Badges','Author',True);
	  BGSForm_chbgVeteran.checked		:= iniFile.ReadBool('Badges','Veteran',True);
	  BGSForm_chbgOwl.checked			:= iniFile.ReadBool('Badges','NightOwl',True);
	  BGSForm_chbgNight.checked			:= iniFile.ReadBool('Badges','DayNight',True);
	  BGSForm_chbgFP.checked			:= iniFile.ReadBool('Badges','FP',True);
	  BGSForm_chbgPhoto.checked			:= iniFile.ReadBool('Badges','Photos',True);	  
	  BGSForm_chbgUniq.checked			:= iniFile.ReadBool('Badges','Uniq',True);
	  //
	  BGSForm_chbgState.checked			:= iniFile.ReadBool('Badges','State',True);
	  BGSForm_chbgEurope.checked		:= iniFile.ReadBool('Badges','Europe',True);
	  BGSForm_chbgAfrica.checked		:= iniFile.ReadBool('Badges','Africa',True);	//Arne1
	  BGSForm_chbgAsia.checked		:= iniFile.ReadBool('Badges','Asia',True);	//Arne1
	  BGSForm_chbgAmer.checked		:= iniFile.ReadBool('Badges','Amer',True);	//Arne1
	  BGSForm_chbgAust.checked		:= iniFile.ReadBool('Badges','Aust',True);	//Arne1
	  BGSForm_chbgEU.checked			:= iniFile.ReadBool('Badges','EU',True);
	  BGSForm_chbgCZDistrict.checked	:= iniFile.ReadBool('Badges','CZDistrict',True);
	  BGSForm_chbgSKDistrict.checked	:= iniFile.ReadBool('Badges','SKDistrict',True);
	  BGSForm_chbgATBezirk.checked		:= iniFile.ReadBool('Badges','ATBezirk',True);
	  //
	  BGSForm_chbgWaymarking.checked	:= iniFile.ReadBool('Badges','Waymarker',False);
	  BGSForm_chbgWaymarkingCr.checked	:= iniFile.ReadBool('Badges','WaymarkerCr',False);
	  BGSForm_chbgWCDiscover.checked	:= iniFile.ReadBool('Badges','WCDiscover',False);
	  //Image URL
	  if (ggsURL <> '') and (BGSForm_cbHTML.Items.IndexOf(ggsURL) > -1) then
		BGSForm_cbHTML.ItemIndex := BGSForm_cbHTML.Items.IndexOf(ggsURL);
	  //From
	  if (ggsFrom <> '') and (BGSForm_cbFrom.Items.IndexOf(ggsFrom) > -1) then
	    BGSForm_cbFrom.ItemIndex := BGSForm_cbFrom.Items.IndexOf(ggsFrom);
	  //DB
	  if (ggs2DB <> '') and (BGSForm_cbDB.Items.IndexOf(ggs2DB) > -1) then
		BGSForm_cbDB.ItemIndex := BGSForm_cbDB.Items.IndexOf(ggs2DB)
	  else
	    BGSForm_cbDB.ItemIndex := BGSForm_cbDB.Items.IndexOf(GEOGET_DBNAME + '.db3');
	  //Encoding
	  if (ggsEncode <> '') and (BGSForm_cbFormat.Items.IndexOf(ggsEncode) > -1) then
		BGSForm_cbFormat.ItemIndex := BGSForm_cbFormat.Items.IndexOf(ggsEncode);
	  //Language
	  if (ggsLang <> '') and (BGSForm_cbLang.Items.IndexOf(ggsLang) > -1) then
		BGSForm_cbLang.ItemIndex := BGSForm_cbLang.Items.IndexOf(ggsLang);
   finally
      iniFile.Free;
   end;
  //
  Result := true;
end;

function SaveToCFG{(typ: integer)} : boolean;
begin
  iniFile := TIniFile.Create(GEOGET_SCRIPTDIR + '\BadgeGenII\' + INI_FILE);
  try
	  iniFile.WriteBool('HTML','BeltYesNo',BGSForm_chbBeltShow.checked);
	  iniFile.WriteBool('HTML','BeltVII',BGSForm_chbBVII.checked);
	  iniFile.WriteBool('HTML','ShowInfo',BGSForm_chbShow.checked);
	  iniFile.WriteBool('HTML','Euro_vs_USA',BGSForm_chbUS.checked);
	  iniFile.WriteBool('HTML','Graph',BGSForm_chbGraph.checked);
	  iniFile.WriteBool('HTML','GraphNumber',BGSForm_chbNumber.checked);
	  iniFile.WriteString('HTML','Url',BGSForm_cbHTML.Items[BGSForm_cbHTML.ItemIndex]);
	  iniFile.WriteString('HTML','From',BGSForm_cbFrom.Items[BGSForm_cbFrom.ItemIndex]);
	  iniFile.WriteString('HTML','Tab1',BGSForm_edTabs1.Text);
	  iniFile.WriteString('HTML','Tab2',BGSForm_edTabs2.Text);
	  iniFile.WriteString('HTML','Tab3',BGSForm_edTabs3.Text);
	  iniFile.WriteBool('HTML','Compact',BGSForm_chbCompact.checked);
	  iniFile.WriteBool('HTML','GVisible',BGSForm_chbVisible.checked);
	  iniFile.WriteString('HTML','Encoding',BGSForm_cbFormat.Items[BGSForm_cbFormat.ItemIndex]);
	  iniFile.WriteString('HTML','Language',BGSForm_cbLang.Items[BGSForm_cbLang.ItemIndex]);
	  iniFile.WriteBool('HTML','ShowDetail',BGSForm_chbDetail.checked);
	  iniFile.WriteBool('HTML','FlagsSepare',BGSForm_chbSFlags.checked);
	  //iniFile.WriteBool('HTML','Stator',BGSForm_chbStator.checked);
	  //color HTML
	  iniFile.WriteString('HTML','CoGraf1',coG1);
	  iniFile.WriteString('HTML','CoGraf2',coG2);
	  iniFile.WriteString('HTML','CoGrafTxt',coGTxt);
	  iniFile.WriteString('HTML','CoButton1',coB1);
	  iniFile.WriteString('HTML','CoButton2',coB2);
	  iniFile.WriteString('HTML','CoButton3',coB3);
	  iniFile.WriteString('HTML','CoButtonTxt1',coBT1);
	  iniFile.WriteString('HTML','CoButtonTxt2',coBT2);
	  iniFile.WriteString('HTML','CoButtonTxt3',coBT3);
	  //inicializace
	  iniFile.WriteString('Initial','Trackables',IntToStr(StrToInt64(BGSForm_edTrackAll.Text)));
	  iniFile.WriteString('Initial','TBs',IntToStr(StrToInt64(BGSForm_edTB.Text)));
	  iniFile.WriteString('Initial','Scubas',IntToStr(StrToInt64(BGSForm_edScuba.Text)));
	  iniFile.WriteString('Initial','CWGs',IntToStr(StrToInt64(BGSForm_edCWG.Text)));
	  iniFile.WriteString('Initial','Benchmarks',IntToStr(StrToInt64(BGSForm_edBench.Text)));
	  iniFile.WriteString('Initial','Owls',IntToStr(StrToInt64(BGSForm_edOwl.Text)));
	  iniFile.WriteString('Initial','Photo',IntToStr(StrToInt64(BGSForm_edPhoto.Text)));
	  //DB
	  iniFile.WriteString('DB','SecondDB',BGSForm_cbDB.Items[BGSForm_cbDB.ItemIndex]);
	  //Size
	  iniFile.WriteString('Size','PageWidth',IntToStr(StrToInt64(BGSForm_edWidth.Text)));
	  iniFile.WriteString('Size','PageMaxHeight',IntToStr(StrToInt64(BGSForm_edMaxHeight.Text)));
	  iniFile.WriteString('Size','ProcBadgeSize',IntToStr(StrToInt64(BGSForm_edBGSize.Text)));
	  iniFile.WriteString('Size','ProcBeltSize',IntToStr(Round((175 * StrToInt(BGSForm_edBBSize.Text))/100.0)));
	  //odznacky
	  iniFile.WriteBool('Badges','Traditional',BGSForm_chbgTraditional.checked);
	  iniFile.WriteBool('Badges','Multi',BGSForm_chbgMulti.checked);
	  iniFile.WriteBool('Badges','Mysterious',BGSForm_chbgMystery.checked);
	  iniFile.WriteBool('Badges','Virtual',BGSForm_chbgVirtual.checked);
	  iniFile.WriteBool('Badges','Earth',BGSForm_chbgEarth.checked);
	  iniFile.WriteBool('Badges','Letter',BGSForm_chbgLetter.checked);
	  iniFile.WriteBool('Badges','Wherigo',BGSForm_chbgWherigo.checked);
	  iniFile.WriteBool('Badges','MEvent',BGSForm_chbgMEvent.checked);
	  iniFile.WriteBool('Badges','Event',BGSForm_chbgEvent.checked);
	  iniFile.WriteBool('Badges','CITO',BGSForm_chbgCITO.checked);
	  iniFile.WriteBool('Badges','LostFound',BGSForm_chbgLostFound.checked);
	  iniFile.WriteBool('Badges','Benchmarker',BGSForm_chbgBenchmark.checked);
	  iniFile.WriteBool('Badges','Webcam',BGSForm_chbgWebcam.checked);
	  iniFile.WriteBool('Badges','Ape',BGSForm_chbgApe.checked);
	  iniFile.WriteBool('Badges','Lab',BGSForm_chbgLab.checked);	//Arne1
	  //
	  iniFile.WriteBool('Badges','Micro',BGSForm_chbgMicro.checked);
	  iniFile.WriteBool('Badges','Small',BGSForm_chbgSmall.checked);
	  iniFile.WriteBool('Badges','Regular',BGSForm_chbgRegular.checked);
	  iniFile.WriteBool('Badges','Large',BGSForm_chbgLarge.checked);
	  //
	  iniFile.WriteBool('Badges','Extrem',BGSForm_chbgExtreme.checked);
	  iniFile.WriteBool('Badges','Lazy',BGSForm_chbgLazy.checked);
	  iniFile.WriteBool('Badges','Diff',BGSForm_chbgDiff.checked);
	  iniFile.WriteBool('Badges','Terr',BGSForm_chbgTerr.checked);
	  //
	  iniFile.WriteBool('Badges','FTF',BGSForm_chbgFTF.checked);
	  iniFile.WriteBool('Badges','WPedestal',BGSForm_chbgWPed.checked);
	  //
	  iniFile.WriteBool('Badges','Hidden',BGSForm_chbgHidden.checked);
	  iniFile.WriteBool('Badges','Host',BGSForm_chbgHost.checked);
	  //
	  iniFile.WriteBool('Badges','Elevation',BGSForm_chbgElevation.checked);
	  iniFile.WriteBool('Badges','UnderGround',BGSForm_chbgLowe.checked);
	  //
	  iniFile.WriteBool('Badges','Travel',BGSForm_chbgTraveling.checked);
	  iniFile.WriteBool('Badges','Busy',BGSForm_chbgBusy.checked);
	  iniFile.WriteBool('Badges','Daily',BGSForm_chbgDaily.checked);
	  iniFile.WriteBool('Badges','Calendar',BGSForm_chbgCalendar.checked);
	  iniFile.WriteBool('Badges','Scuba',BGSForm_chbgScuba.checked);
	  iniFile.WriteBool('Badges','Distance',BGSForm_chbgLongDistance.checked);
	  iniFile.WriteBool('Badges','Matrix',BGSForm_chbgMatrix.checked);
	  iniFile.WriteBool('Badges','TravelBug',BGSForm_chbgTB.checked);
	  iniFile.WriteBool('Badges','Coin',BGSForm_chbgCoin.checked);
	  iniFile.WriteBool('Badges','CWG',BGSForm_chbgCWG.checked);
	  iniFile.WriteBool('Badges','Author',BGSForm_chbgAuthor.checked);
	  iniFile.WriteBool('Badges','Veteran',BGSForm_chbgVeteran.checked);
	  iniFile.WriteBool('Badges','NightOwl',BGSForm_chbgOwl.checked);
	  iniFile.WriteBool('Badges','DayNight',BGSForm_chbgNight.checked);
	  iniFile.WriteBool('Badges','FP',BGSForm_chbgFP.checked);
	  iniFile.WriteBool('Badges','Photos',BGSForm_chbgPhoto.checked);	  
	  iniFile.WriteBool('Badges','Uniq',BGSForm_chbgUniq.checked);
	  //
	  iniFile.WriteBool('Badges','State',BGSForm_chbgState.checked);
	  iniFile.WriteBool('Badges','Europe',BGSForm_chbgEurope.checked);
	  iniFile.WriteBool('Badges','Africa',BGSForm_chbgAfrica.checked);	//Arne1
	  iniFile.WriteBool('Badges','Asia',BGSForm_chbgAsia.checked);	//Arne1
	  iniFile.WriteBool('Badges','Amer',BGSForm_chbgAmer.checked);	//Arne1
	  iniFile.WriteBool('Badges','Aust',BGSForm_chbgAust.checked);	//Arne1
	  iniFile.WriteBool('Badges','EU',BGSForm_chbgEU.checked);
	  iniFile.WriteBool('Badges','CZDistrict',BGSForm_chbgCZDistrict.checked);
	  iniFile.WriteBool('Badges','SKDistrict',BGSForm_chbgSKDistrict.checked);
	  iniFile.WriteBool('Badges','ATBezirk',BGSForm_chbgATBezirk.checked);
	  //
	  iniFile.WriteBool('Badges','Waymarker',BGSForm_chbgWaymarking.checked);
	  iniFile.WriteBool('Badges','WaymarkerCr',BGSForm_chbgWaymarkingCr.checked);
	  iniFile.WriteBool('Badges','WCDiscover',BGSForm_chbgWCDiscover.checked);
  finally
      iniFile.Free;
  end;  
  //
  Result := true;
end;

procedure ParseDelimited(const sl : TStringList; const value : string; const delimiter : string) ;
var
   dx : integer;
   ns : string;
   txt : string;
   delta : integer;
begin
   delta := Length(delimiter) ;
   txt := value + delimiter;
   sl.BeginUpdate;
   sl.Clear;
   try
     while Length(txt) > 0 do
     begin
       dx := Pos(delimiter, txt) ;
       ns := Copy(txt,0,dx-1) ;
       if trim(ns) <> '' then sl.Add(ns) ;
       txt := Copy(txt,dx+delta,65536) ;
     end;
   finally
     sl.EndUpdate;
   end;
end;

function ParseDistanceCache():String;
var
  i,j: integer;
  sl: TStringList;
  tmp, gc, templatefile, code: String;
begin
  templatefile := RelToAbsFilename(TEMPLATE_FILE, GEOGET_DATADIR);
  //ShowMessage(templatefile);
  if FileExists(templatefile) then begin
    tmp := FileToString(templatefile);
	//ShowHTMLMessage('test',tmp);
    sl := TStringList.Create;
	try
		ParseDelimited(sl, tmp, #13#10);
		for i := 0 to sl.Count-1 do begin
			if Copy(Trim(sl[i]),1,1) = '#' then continue;			//komente
			if Pos('IGNOREBYDISTANCE',AnsiUppercase(Trim(sl[i]))) > 0 then begin
				gc := Trim(sl[i])
				break;
			end;
		end;
	finally
	  sl.Free();
	end;
  end
  else
    ShowMessage(_('Not found template file: ') + templatefile
    	+ CRLF + CRLF + _('For setting go to menu "Plugin" --> "Plugins manager" --> "Plugins config" --> "BadgeGenII\badgegenii" and set correct path to file Template.cs/en...'));
  //ShowMessage(gc);
  //kdy PARSE
  code := '';
  if Trim(gc) <> '' then begin
	sl := TStringList.Create;
	j := 1
	try
		ParseDelimited(sl, gc, ' ');
		for i := 0 to sl.Count-1 do begin
			//ShowMessage(sl[i]);
			if Trim(sl[i]) = '' then continue;
			if AnsiUppercase(Trim(sl[i])) = 'IGNOREBYDISTANCE' then continue;
			code := code + Trim(sl[i]) + ',';
			j := j + 1;
		end;
	finally
		sl.Free();
		code := Copy(code, 1, Length(code)-1)
	end;
  end;
  Result := code;
end;

function RGBBGR(c:String):String;
begin
  Result := '$' + Copy(c,6,2) + Copy(c,4,2) + Copy(c,2,2);
end;

function ReadColorFromCSVFile(): boolean;
var
  i: integer;
  sl: TStringList;
  csv, cc: String;
  ccount : integer;
begin
  ccount := 0;
  Result := False;
  if FileExists(GEOGET_SCRIPTDIR + '\BadgeGenII\' + COLOR_FILE) then begin
    csv := FileToString(GEOGET_SCRIPTDIR + '\BadgeGenII\' + COLOR_FILE);
    sl := TStringList.Create;
	try
		ParseDelimited(sl, csv, #13#10);
		for i := 1 to sl.Count-1 do begin		//od 1 neb na nultm je hlavika...
			Inc(ccount);
			SetLength(FColor, ccount);
			//
			FColor[ccount-1].ColorName := SeparateLeft(sl[i],',');
			cc := SeparateRight(sl[i],',');
			FColor[ccount-1].SCode := cc;
			FColor[ccount-1].Code := StrToInt(RGBBGR(cc));
			//
		end;
	finally
	  sl.Free();	
	end;
	//ShowMessage(FColor[0].ColorName + ' ' + FColor[0].Code);
  end
  else Result := True;
end;

procedure cbLoadColor(cb : TComboBox; cc: String);
var
  i: integer;
  cidx: integer;
  cx : string;
begin
	//ShowMessage(cc);
	cx := '#' + cc;
	cb.Clear; cidx := 0;
	For i := Low(FColor) to High(FColor) do begin
	  cb.items.Add(FColor[i].SCode);
	  if Uppercase(FColor[i].SCode) = Uppercase(cx) then cidx := i;
	end;
	cb.ItemIndex := cidx;
end;

procedure SetColor;
begin
	//
	coG1	:= Copy(FColor[BGSForm_cbGraf1.ItemIndex].SCode,2,6);
	coG2	:= Copy(FColor[BGSForm_cbGraf2.ItemIndex].SCode,2,6);
	coGTxt	:= Copy(FColor[BGSForm_cbGrafText.ItemIndex].SCode,2,6);
	coB1	:= Copy(FColor[BGSForm_cbButt1.ItemIndex].SCode,2,6);
	coB2	:= Copy(FColor[BGSForm_cbButt2.ItemIndex].SCode,2,6);
	coB3	:= Copy(FColor[BGSForm_cbButt3.ItemIndex].SCode,2,6);
	coBT1	:= Copy(FColor[BGSForm_cbTButt1.ItemIndex].SCode,2,6);
	coBT2	:= Copy(FColor[BGSForm_cbTButt2.ItemIndex].SCode,2,6);
	coBT3	:= Copy(FColor[BGSForm_cbTButt3.ItemIndex].SCode,2,6);
	//
end;
//------------------------------------------------------------------------------
procedure ColorOnDrawItem(cb: TWinControl; Index: Integer; Rect: TRect;
  State: byte {podle dokumentace je typu TOwnerDrawState, ale v enginu je byte});
begin
    TComboBox(cb).Canvas.Brush.Color := TColor(FColor[Index].Code) ;
    TComboBox(cb).Canvas.FillRect(Rect) ;
	if FColor[Index].Code = 0 then TComboBox(cb).Canvas.Font.Color := $FFFFFF else TComboBox(cb).Canvas.Font.Color := $000000;
	TComboBox(cb).Canvas.TextOut(Rect.Left, Rect.Top, {'(' + Uppercase(FColor[Index].SCode) +  ') ' +} FColor[Index].ColorName);
end;

function Footer() :string;
var
  outhtml : string;
begin
    outhtml := '';
	outhtml := outhtml + '<br />' + CRLF;
	outhtml := outhtml + '<div style="text-align: center;">' + CRLF + '<a href="http://www.badgegen.com/badges.html">Available Badges from BadgeGen</a> or <a href="http://www.drakmrak.cz/doku.php?id=geo:badgegen">Czech info</a>,<a href="http://www.drakmrak.cz/doku.php?id=geo:badgegeninfo">[1]</a>,';
	if BGSForm_chbBVII.checked then
		outhtml := outhtml + '<a href="http://www.drakmrak.cz/doku.php?id=geo:beltinfoii">[2]</a>' + CRLF + '</div>' + CRLF
	else
		outhtml := outhtml + '<a href="http://www.drakmrak.cz/doku.php?id=geo:badgegenbeltinfo">[2]</a>' + CRLF + '</div>' + CRLF;
	outhtml := outhtml + '<div align="center">The Groundspeak Geocaching Logo is a trademark of <a href="http://www.geocaching.com/">Groundspeak, Inc.</a> and used with permission.</div>' + CRLF;
	outhtml := outhtml + '<div align="center">Inspired by <a href="http://www.badgegen.com/">BadgeGen</a> from <b>ky.m.guy</b></div>' + CRLF;
	outhtml := outhtml + '<div style="text-align:center; font-weight:bold; color:#6484FF">Version: ' + Verze + ' by DrakMrak</div>' + CRLF;
	Result := outhtml;
end;

